# swagger.api.AccountManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiFileUploadPOST**](AccountManagementApi.md#apiFileUploadPOST) | **POST** /api/1/users/file | upload file  
[**apiForgotPasswordPOST**](AccountManagementApi.md#apiForgotPasswordPOST) | **POST** /api/1/forgotPassword/ | User forgot password 
[**apiLoginPOST**](AccountManagementApi.md#apiLoginPOST) | **POST** /api/1/login/ | User login 
[**apiLogoutPOST**](AccountManagementApi.md#apiLogoutPOST) | **POST** /api/1/logout/ | User logout 
[**apiRegisterPOST**](AccountManagementApi.md#apiRegisterPOST) | **POST** /api/1/register/ | User signup 
[**apiResendEmailPOST**](AccountManagementApi.md#apiResendEmailPOST) | **POST** /api/1/resendEmail/ | Resend verification email 
[**apiResetPasswordPOST**](AccountManagementApi.md#apiResetPasswordPOST) | **POST** /api/1/resetPassword/{tokenId} | Reset password 
[**apiUserDataPOST**](AccountManagementApi.md#apiUserDataPOST) | **POST** /api/1/userData/ | Update user data 
[**apiUsersMeGET**](AccountManagementApi.md#apiUsersMeGET) | **GET** /api/1/users/me/ | Get user data 
[**apiVerifyEmailPOST**](AccountManagementApi.md#apiVerifyEmailPOST) | **POST** /api/1/verifyEmail/{tokenId} | Verify email address 


# **apiFileUploadPOST**
> MessageRes apiFileUploadPOST(type, file)

upload file  

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var type = type_example; // String | Upload file type
var file = /path/to/file.txt; // MultipartFile | file to upload

try { 
    var result = api_instance.apiFileUploadPOST(type, file);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiFileUploadPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**| Upload file type | 
 **file** | **MultipartFile**| file to upload | 

### Return type

[**MessageRes**](MessageRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiForgotPasswordPOST**
> SuccessRes apiForgotPasswordPOST(body)

User forgot password 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var body = new ForgotPasswordReq(); // ForgotPasswordReq | 

try { 
    var result = api_instance.apiForgotPasswordPOST(body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiForgotPasswordPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ForgotPasswordReq**](ForgotPasswordReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiLoginPOST**
> InlineResponse200 apiLoginPOST(body)

User login 

### Example 
```dart
import 'package:swagger/api.dart';

var api_instance = new AccountManagementApi();
var body = new LoginReq(); // LoginReq | 

try { 
    var result = api_instance.apiLoginPOST(body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiLoginPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**LoginReq**](LoginReq.md)|  | 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiLogoutPOST**
> SuccessRes apiLogoutPOST()

User logout 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();

try { 
    var result = api_instance.apiLogoutPOST();
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiLogoutPOST: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiRegisterPOST**
> SuccessRes apiRegisterPOST(body)

User signup 

### Example 
```dart
import 'package:swagger/api.dart';

var api_instance = new AccountManagementApi();
var body = new RegisterReq(); // RegisterReq | 

try { 
    var result = api_instance.apiRegisterPOST(body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiRegisterPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**RegisterReq**](RegisterReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiResendEmailPOST**
> SuccessRes apiResendEmailPOST(body)

Resend verification email 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var body = new ForgotPasswordReq(); // ForgotPasswordReq | 

try { 
    var result = api_instance.apiResendEmailPOST(body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiResendEmailPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ForgotPasswordReq**](ForgotPasswordReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiResetPasswordPOST**
> SuccessRes apiResetPasswordPOST(tokenId, body)

Reset password 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var tokenId = tokenId_example; // String | token id
var body = new ResetPasswordReq(); // ResetPasswordReq | 

try { 
    var result = api_instance.apiResetPasswordPOST(tokenId, body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiResetPasswordPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenId** | **String**| token id | 
 **body** | [**ResetPasswordReq**](ResetPasswordReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiUserDataPOST**
> SuccessRes apiUserDataPOST(body)

Update user data 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var body = new UserDataReq(); // UserDataReq | 

try { 
    var result = api_instance.apiUserDataPOST(body);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiUserDataPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**UserDataReq**](UserDataReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiUsersMeGET**
> UserMeRes apiUsersMeGET()

Get user data 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();

try { 
    var result = api_instance.apiUsersMeGET();
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiUsersMeGET: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**UserMeRes**](UserMeRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiVerifyEmailPOST**
> SuccessRes apiVerifyEmailPOST(tokenId)

Verify email address 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new AccountManagementApi();
var tokenId = tokenId_example; // String | token id

try { 
    var result = api_instance.apiVerifyEmailPOST(tokenId);
    print(result);
} catch (e) {
    print("Exception when calling AccountManagementApi->apiVerifyEmailPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenId** | **String**| token id | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

