# swagger.api.DeviceManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiControllerCtrlPOST**](DeviceManagementApi.md#apiControllerCtrlPOST) | **POST** /api/1/controllers/{controllerId}/ctrl/ | Control a controller 
[**apiControllerDELETE**](DeviceManagementApi.md#apiControllerDELETE) | **DELETE** /api/1/controllers | Delete a controller 
[**apiControllerGET**](DeviceManagementApi.md#apiControllerGET) | **GET** /api/1/controllers | Get controller info 
[**apiControllerPATCH**](DeviceManagementApi.md#apiControllerPATCH) | **PATCH** /api/1/controllers | Update a controller 
[**apiControllerPOST**](DeviceManagementApi.md#apiControllerPOST) | **POST** /api/1/controllers | Add a controller 
[**apiControllerPUT**](DeviceManagementApi.md#apiControllerPUT) | **PUT** /api/1/controllers | Put a controller 
[**apiDeviceChannelCtrlPOST**](DeviceManagementApi.md#apiDeviceChannelCtrlPOST) | **POST** /api/1/controllers/{controllerId}/devices/{devId}/channels/{channelId}/ctrl/ | Control a channel of a specified device property 
[**apiDeviceCtrlPOST**](DeviceManagementApi.md#apiDeviceCtrlPOST) | **POST** /api/1/controllers/{controllerId}/devices/{devId}/ctrl/ | Control a device property 
[**apiDevicesDELETE**](DeviceManagementApi.md#apiDevicesDELETE) | **DELETE** /api/1/controllers/{controllerId}/devices | Delete a controller&#39;s devices 
[**apiDevicesGet**](DeviceManagementApi.md#apiDevicesGet) | **GET** /api/1/controllers/{controllerId}/devices | Get devices info 
[**apiDevicesPATCH**](DeviceManagementApi.md#apiDevicesPATCH) | **PATCH** /api/1/controllers/{controllerId}/devices | Update a controller&#39;s devices 
[**apiDevicesPOST**](DeviceManagementApi.md#apiDevicesPOST) | **POST** /api/1/controllers/{controllerId}/devices | Add a controller&#39;s devices 
[**apiDevicesPUT**](DeviceManagementApi.md#apiDevicesPUT) | **PUT** /api/1/controllers/{controllerId}/devices | Put a controller&#39;s devices 
[**apiGetControllerTimezone**](DeviceManagementApi.md#apiGetControllerTimezone) | **GET** /api/1/controllers/{controllerId}/timezone | Get timezone info 
[**apiGetControllerWeather**](DeviceManagementApi.md#apiGetControllerWeather) | **GET** /api/1/controllers/{controllerId}/weather | Get weather info 


# **apiControllerCtrlPOST**
> SuccessRes apiControllerCtrlPOST(controllerId, body)

Control a controller 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | 
var body = new ControllerCtrlReq(); // ControllerCtrlReq | 

try { 
    var result = api_instance.apiControllerCtrlPOST(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerCtrlPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **body** | [**ControllerCtrlReq**](ControllerCtrlReq.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerDELETE**
> SuccessRes apiControllerDELETE(controllerId)

Delete a controller 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllerDELETE(controllerId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerDELETE: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerGET**
> GetControllersRes apiControllerGET(controllerId)

Get controller info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllerGET(controllerId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | [optional] 

### Return type

[**GetControllersRes**](GetControllersRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerPATCH**
> SuccessRes apiControllerPATCH(body, time, controllerId)

Update a controller 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var body = new ControllerItem(); // ControllerItem | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllerPATCH(body, time, controllerId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerPATCH: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ControllerItem**](ControllerItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 
 **controllerId** | **String**| controller id | [optional] 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerPOST**
> SuccessRes apiControllerPOST(body, time, controllerId)

Add a controller 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var body = new ControllerItem(); // ControllerItem | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllerPOST(body, time, controllerId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ControllerItem**](ControllerItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 
 **controllerId** | **String**| controller id | [optional] 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerPUT**
> SuccessRes apiControllerPUT(body, time, controllerId)

Put a controller 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var body = new ControllerItem(); // ControllerItem | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllerPUT(body, time, controllerId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiControllerPUT: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ControllerItem**](ControllerItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 
 **controllerId** | **String**| controller id | [optional] 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDeviceChannelCtrlPOST**
> SuccessRes apiDeviceChannelCtrlPOST(controllerId, devId, channelId, body)

Control a channel of a specified device property 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var channelId = channelId_example; // String | 
var body = new CtrlItem(); // CtrlItem | 

try { 
    var result = api_instance.apiDeviceChannelCtrlPOST(controllerId, devId, channelId, body);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDeviceChannelCtrlPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **channelId** | **String**|  | 
 **body** | [**CtrlItem**](CtrlItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDeviceCtrlPOST**
> SuccessRes apiDeviceCtrlPOST(controllerId, devId, body)

Control a device property 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var body = new CtrlItem(); // CtrlItem | 

try { 
    var result = api_instance.apiDeviceCtrlPOST(controllerId, devId, body);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDeviceCtrlPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **body** | [**CtrlItem**](CtrlItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDevicesDELETE**
> SuccessRes apiDevicesDELETE(controllerId, devId)

Delete a controller's devices 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id
var devId = devId_example; // String | device id

try { 
    var result = api_instance.apiDevicesDELETE(controllerId, devId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDevicesDELETE: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **devId** | **String**| device id | [optional] 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDevicesGet**
> GetDevicesRes apiDevicesGet(controllerId, devId)

Get devices info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id
var devId = devId_example; // String | device id

try { 
    var result = api_instance.apiDevicesGet(controllerId, devId);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDevicesGet: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **devId** | **String**| device id | [optional] 

### Return type

[**GetDevicesRes**](GetDevicesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDevicesPATCH**
> OperDevicesRes apiDevicesPATCH(controllerId, body, time)

Update a controller's devices 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id
var body = [new List&lt;DeviceItem&gt;()]; // List<DeviceItem> | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time

try { 
    var result = api_instance.apiDevicesPATCH(controllerId, body, time);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDevicesPATCH: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **body** | [**List&lt;DeviceItem&gt;**](DeviceItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 

### Return type

[**OperDevicesRes**](OperDevicesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDevicesPOST**
> OperDevicesRes apiDevicesPOST(controllerId, body, time)

Add a controller's devices 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id
var body = [new List&lt;DeviceItem&gt;()]; // List<DeviceItem> | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time

try { 
    var result = api_instance.apiDevicesPOST(controllerId, body, time);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDevicesPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **body** | [**List&lt;DeviceItem&gt;**](DeviceItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 

### Return type

[**OperDevicesRes**](OperDevicesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDevicesPUT**
> OperDevicesRes apiDevicesPUT(controllerId, body, time)

Put a controller's devices 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | controller id
var body = [new List&lt;DeviceItem&gt;()]; // List<DeviceItem> | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time

try { 
    var result = api_instance.apiDevicesPUT(controllerId, body, time);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiDevicesPUT: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **body** | [**List&lt;DeviceItem&gt;**](DeviceItem.md)|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | [optional] 

### Return type

[**OperDevicesRes**](OperDevicesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGetControllerTimezone**
> TimezoneRes apiGetControllerTimezone(controllerId, zip, country)

Get timezone info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | 
var zip = zip_example; // String | zip code to query
var country = country_example; // String | country abbreviation to query, ex: GB/DE, refer from https://en.wikipedia.org/wiki/ISO_3166-1

try { 
    var result = api_instance.apiGetControllerTimezone(controllerId, zip, country);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiGetControllerTimezone: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **zip** | **String**| zip code to query | [optional] 
 **country** | **String**| country abbreviation to query, ex: GB/DE, refer from https://en.wikipedia.org/wiki/ISO_3166-1 | [optional] 

### Return type

[**TimezoneRes**](TimezoneRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGetControllerWeather**
> WeatherRes apiGetControllerWeather(controllerId, type, country, zip, interval)

Get weather info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new DeviceManagementApi();
var controllerId = controllerId_example; // String | 
var type = type_example; // String | query type: current: today detail weather, hourly: forecast future 24 hours weather, daily: forecast future 7 days weather
var country = country_example; // String | country abbreviation to query, ex: GB/DE, refer from https://en.wikipedia.org/wiki/ISO_3166-1
var zip = zip_example; // String | zip code to query
var interval = interval_example; // String | query hourly weather interval: works on 'hourly' type

try { 
    var result = api_instance.apiGetControllerWeather(controllerId, type, country, zip, interval);
    print(result);
} catch (e) {
    print("Exception when calling DeviceManagementApi->apiGetControllerWeather: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **type** | **String**| query type: current: today detail weather, hourly: forecast future 24 hours weather, daily: forecast future 7 days weather | [optional] 
 **country** | **String**| country abbreviation to query, ex: GB/DE, refer from https://en.wikipedia.org/wiki/ISO_3166-1 | [optional] 
 **zip** | **String**| zip code to query | [optional] 
 **interval** | **String**| query hourly weather interval: works on &#39;hourly&#39; type | [optional] 

### Return type

[**WeatherRes**](WeatherRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

