# swagger.api.EventHandleApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiAlert**](EventHandleApi.md#apiAlert) | **POST** /api/1/event/controllers/{controllerId}/alert | alert handle 
[**apiBatchHandlePOST**](EventHandleApi.md#apiBatchHandlePOST) | **POST** /api/1/event/controllers/{controllerId}/batchHandle | Batch handle event
[**apiEventDefGET**](EventHandleApi.md#apiEventDefGET) | **GET** /api/1/event/def/ | event trigger 
[**apiEventHandle**](EventHandleApi.md#apiEventHandle) | **POST** /api/1/event/handle | event trigger 
[**apiHandleFilePOST**](EventHandleApi.md#apiHandleFilePOST) | **POST** /api/1/event/controllers/{controllerId}/devices/{devId}/file | Handle event with file


# **apiAlert**
> AlertRes apiAlert(controllerId, body)

alert handle 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new EventHandleApi();
var controllerId = controllerId_example; // String | 
var body = [new List&lt;LogItem&gt;()]; // List<LogItem> | 

try { 
    var result = api_instance.apiAlert(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling EventHandleApi->apiAlert: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **body** | [**List&lt;LogItem&gt;**](LogItem.md)|  | 

### Return type

[**AlertRes**](AlertRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiBatchHandlePOST**
> MessageRes apiBatchHandlePOST(controllerId, type, group, body, notifyController)

Batch handle event

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new EventHandleApi();
var controllerId = controllerId_example; // String | 
var type = type_example; // String | everythingIsFine, callGuardian, callAlarmCenter
var group = group_example; // String | event_batch
var body = [new List&lt;SimplyEventItem&gt;()]; // List<SimplyEventItem> | 
var notifyController = true; // bool | Notify controller about this batch handle event. It's effective only if the client type of token is mobile. Default: false

try { 
    var result = api_instance.apiBatchHandlePOST(controllerId, type, group, body, notifyController);
    print(result);
} catch (e) {
    print("Exception when calling EventHandleApi->apiBatchHandlePOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **type** | **String**| everythingIsFine, callGuardian, callAlarmCenter | 
 **group** | **String**| event_batch | 
 **body** | [**List&lt;SimplyEventItem&gt;**](SimplyEventItem.md)|  | 
 **notifyController** | **bool**| Notify controller about this batch handle event. It&#39;s effective only if the client type of token is mobile. Default: false | [optional] 

### Return type

[**MessageRes**](MessageRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiEventDefGET**
> DefinedEventsRes apiEventDefGET()

event trigger 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new EventHandleApi();

try { 
    var result = api_instance.apiEventDefGET();
    print(result);
} catch (e) {
    print("Exception when calling EventHandleApi->apiEventDefGET: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**DefinedEventsRes**](DefinedEventsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiEventHandle**
> MessageRes apiEventHandle(body)

event trigger 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new EventHandleApi();
var body = new EventItem(); // EventItem | 

try { 
    var result = api_instance.apiEventHandle(body);
    print(result);
} catch (e) {
    print("Exception when calling EventHandleApi->apiEventHandle: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**EventItem**](EventItem.md)|  | 

### Return type

[**MessageRes**](MessageRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiHandleFilePOST**
> SuccessRes apiHandleFilePOST(controllerId, devId, time, type, file, data)

Handle event with file

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new EventHandleApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var time = time_example; // String | For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time
var type = type_example; // String | file type
var file = /path/to/file.txt; // MultipartFile | file to upload
var data = data_example; // String | data

try { 
    var result = api_instance.apiHandleFilePOST(controllerId, devId, time, type, file, data);
    print(result);
} catch (e) {
    print("Exception when calling EventHandleApi->apiHandleFilePOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **time** | **String**| For connection restore use, (milliseconds, UNIX format, 1577836800000 represents 2020/1/1), empty value represents current time | 
 **type** | **String**| file type | 
 **file** | **MultipartFile**| file to upload | 
 **data** | **String**| data | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

