# swagger.api.FamilyAccountManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiPrivilegeDELETE**](FamilyAccountManagementApi.md#apiPrivilegeDELETE) | **DELETE** /api/1/controllers/{controllerId}/privilege | Delete a family account 
[**apiPrivilegePATCH**](FamilyAccountManagementApi.md#apiPrivilegePATCH) | **PATCH** /api/1/controllers/{controllerId}/privilege | Update a family account 
[**apiPrivilegePOST**](FamilyAccountManagementApi.md#apiPrivilegePOST) | **POST** /api/1/controllers/{controllerId}/privilege | Add a family account 
[**apiPrivilegeResendMail**](FamilyAccountManagementApi.md#apiPrivilegeResendMail) | **POST** /api/1/controllers/{controllerId}/privilege/sendMail | resend invite mail 
[**apiPrivilegesGet**](FamilyAccountManagementApi.md#apiPrivilegesGet) | **GET** /api/1/privileges/ | Get pre-defined family account privileges 


# **apiPrivilegeDELETE**
> SuccessRes apiPrivilegeDELETE(controllerId, email)

Delete a family account 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new FamilyAccountManagementApi();
var controllerId = controllerId_example; // String | 
var email = email_example; // String | email

try { 
    var result = api_instance.apiPrivilegeDELETE(controllerId, email);
    print(result);
} catch (e) {
    print("Exception when calling FamilyAccountManagementApi->apiPrivilegeDELETE: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **email** | **String**| email | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiPrivilegePATCH**
> SuccessRes apiPrivilegePATCH(controllerId, body)

Update a family account 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new FamilyAccountManagementApi();
var controllerId = controllerId_example; // String | 
var body = new PrivilegeItem(); // PrivilegeItem | 

try { 
    var result = api_instance.apiPrivilegePATCH(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling FamilyAccountManagementApi->apiPrivilegePATCH: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **body** | [**PrivilegeItem**](PrivilegeItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiPrivilegePOST**
> SuccessRes apiPrivilegePOST(controllerId, body)

Add a family account 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new FamilyAccountManagementApi();
var controllerId = controllerId_example; // String | 
var body = new PrivilegeItem(); // PrivilegeItem | 

try { 
    var result = api_instance.apiPrivilegePOST(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling FamilyAccountManagementApi->apiPrivilegePOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **body** | [**PrivilegeItem**](PrivilegeItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiPrivilegeResendMail**
> SuccessRes apiPrivilegeResendMail(controllerId, body)

resend invite mail 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new FamilyAccountManagementApi();
var controllerId = controllerId_example; // String | 
var body = new PrivilegeItem(); // PrivilegeItem | 

try { 
    var result = api_instance.apiPrivilegeResendMail(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling FamilyAccountManagementApi->apiPrivilegeResendMail: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **body** | [**PrivilegeItem**](PrivilegeItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiPrivilegesGet**
> DefinedPrivilegesRes apiPrivilegesGet()

Get pre-defined family account privileges 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new FamilyAccountManagementApi();

try { 
    var result = api_instance.apiPrivilegesGet();
    print(result);
} catch (e) {
    print("Exception when calling FamilyAccountManagementApi->apiPrivilegesGet: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**DefinedPrivilegesRes**](DefinedPrivilegesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

