# swagger.api.LogManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**api1LogsGet**](LogManagementApi.md#api1LogsGet) | **GET** /api/1/logs | Get all controller logs by user 
[**apiControllerLogsGET**](LogManagementApi.md#apiControllerLogsGET) | **GET** /api/1/controllers/{controllerId}/logs | Get a controller&#39;s logs 
[**apiDeviceLogsGET**](LogManagementApi.md#apiDeviceLogsGET) | **GET** /api/1/controllers/{controllerId}/devices/{devId}/logs | Get a device&#39;s logs 
[**apiSyncLogs**](LogManagementApi.md#apiSyncLogs) | **POST** /api/1/logs/sync | sync logs 
[**apiSyncSnapshotPOST**](LogManagementApi.md#apiSyncSnapshotPOST) | **POST** /api/1/logs/controllers/{controllerId}/devices/{devId}/sync/snapshot/ | Sync logs with snapshot  


# **api1LogsGet**
> GetLogsRes api1LogsGet(limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal)

Get all controller logs by user 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new LogManagementApi();
var limit = 8.14; // num | number of logs returned
var offset = 8.14; // num | returns the specified record start position
var logType = logType_example; // String | Specify filter conditions
var startTime = startTime_example; // String | Specify filter conditions
var endTime = endTime_example; // String | Specify filter conditions
var startCreatedAt = startCreatedAt_example; // String | Specify filter conditions
var endCreatedAt = endCreatedAt_example; // String | Specify filter conditions
var getTotal = true; // bool | Set true to get total number of logs under filter conditions(neglect limit)

try { 
    var result = api_instance.api1LogsGet(limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal);
    print(result);
} catch (e) {
    print("Exception when calling LogManagementApi->api1LogsGet: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **num**| number of logs returned | [optional] 
 **offset** | **num**| returns the specified record start position | [optional] 
 **logType** | **String**| Specify filter conditions | [optional] 
 **startTime** | **String**| Specify filter conditions | [optional] 
 **endTime** | **String**| Specify filter conditions | [optional] 
 **startCreatedAt** | **String**| Specify filter conditions | [optional] 
 **endCreatedAt** | **String**| Specify filter conditions | [optional] 
 **getTotal** | **bool**| Set true to get total number of logs under filter conditions(neglect limit) | [optional] [default to false]

### Return type

[**GetLogsRes**](GetLogsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerLogsGET**
> GetLogsRes apiControllerLogsGET(controllerId, limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal)

Get a controller's logs 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new LogManagementApi();
var controllerId = controllerId_example; // String | 
var limit = 8.14; // num | number of logs returned
var offset = 8.14; // num | returns the specified record start position
var logType = logType_example; // String | Specify filter conditions
var startTime = startTime_example; // String | Specify filter conditions
var endTime = endTime_example; // String | Specify filter conditions
var startCreatedAt = startCreatedAt_example; // String | Specify filter conditions
var endCreatedAt = endCreatedAt_example; // String | Specify filter conditions
var getTotal = true; // bool | Set true to get total number of logs under filter conditions(neglect limit)

try { 
    var result = api_instance.apiControllerLogsGET(controllerId, limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal);
    print(result);
} catch (e) {
    print("Exception when calling LogManagementApi->apiControllerLogsGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **limit** | **num**| number of logs returned | [optional] 
 **offset** | **num**| returns the specified record start position | [optional] 
 **logType** | **String**| Specify filter conditions | [optional] 
 **startTime** | **String**| Specify filter conditions | [optional] 
 **endTime** | **String**| Specify filter conditions | [optional] 
 **startCreatedAt** | **String**| Specify filter conditions | [optional] 
 **endCreatedAt** | **String**| Specify filter conditions | [optional] 
 **getTotal** | **bool**| Set true to get total number of logs under filter conditions(neglect limit) | [optional] [default to false]

### Return type

[**GetLogsRes**](GetLogsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiDeviceLogsGET**
> GetLogsRes apiDeviceLogsGET(controllerId, devId, limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal)

Get a device's logs 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new LogManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var limit = 8.14; // num | number of logs returned
var offset = 8.14; // num | returns the specified record start position
var logType = logType_example; // String | Specify filter conditions
var startTime = startTime_example; // String | Specify filter conditions
var endTime = endTime_example; // String | Specify filter conditions
var startCreatedAt = startCreatedAt_example; // String | Specify filter conditions
var endCreatedAt = endCreatedAt_example; // String | Specify filter conditions
var getTotal = true; // bool | Set true to get total number of logs under filter conditions(neglect limit)

try { 
    var result = api_instance.apiDeviceLogsGET(controllerId, devId, limit, offset, logType, startTime, endTime, startCreatedAt, endCreatedAt, getTotal);
    print(result);
} catch (e) {
    print("Exception when calling LogManagementApi->apiDeviceLogsGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **limit** | **num**| number of logs returned | [optional] 
 **offset** | **num**| returns the specified record start position | [optional] 
 **logType** | **String**| Specify filter conditions | [optional] 
 **startTime** | **String**| Specify filter conditions | [optional] 
 **endTime** | **String**| Specify filter conditions | [optional] 
 **startCreatedAt** | **String**| Specify filter conditions | [optional] 
 **endCreatedAt** | **String**| Specify filter conditions | [optional] 
 **getTotal** | **bool**| Set true to get total number of logs under filter conditions(neglect limit) | [optional] [default to false]

### Return type

[**GetLogsRes**](GetLogsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiSyncLogs**
> GetLogsRes apiSyncLogs(body, end)

sync logs 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new LogManagementApi();
var body = [new List&lt;LogItem&gt;()]; // List<LogItem> | 
var end = end_example; // String | 1=true 0=false

try { 
    var result = api_instance.apiSyncLogs(body, end);
    print(result);
} catch (e) {
    print("Exception when calling LogManagementApi->apiSyncLogs: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**List&lt;LogItem&gt;**](LogItem.md)|  | 
 **end** | **String**| 1&#x3D;true 0&#x3D;false | [optional] 

### Return type

[**GetLogsRes**](GetLogsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiSyncSnapshotPOST**
> SuccessRes apiSyncSnapshotPOST(controllerId, devId, end, time, file, data)

Sync logs with snapshot  

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new LogManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var end = end_example; // String | 1=true 0=false
var time = time_example; // String | event time that triggered snapshot
var file = /path/to/file.txt; // MultipartFile | file to upload
var data = data_example; // String | data

try { 
    var result = api_instance.apiSyncSnapshotPOST(controllerId, devId, end, time, file, data);
    print(result);
} catch (e) {
    print("Exception when calling LogManagementApi->apiSyncSnapshotPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **end** | **String**| 1&#x3D;true 0&#x3D;false | 
 **time** | **String**| event time that triggered snapshot | 
 **file** | **MultipartFile**| file to upload | 
 **data** | **String**| data | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

