# swagger.api.ReportManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiBrandReportGET**](ReportManagementApi.md#apiBrandReportGET) | **GET** /api/1/brands/{brandName}/reports | Get reports depends on brand name 
[**apiBrandTypeReportGET**](ReportManagementApi.md#apiBrandTypeReportGET) | **GET** /api/1/brands/{brandName}/types/{typeEnum}/reports | Get reports depends on brand name and periodical type 
[**apiReportGET**](ReportManagementApi.md#apiReportGET) | **GET** /api/1/reports | Get reports 
[**apiReportSupportFieldsGET**](ReportManagementApi.md#apiReportSupportFieldsGET) | **GET** /api/1/reports/supportFields | Get support fields of report 


# **apiBrandReportGET**
> ReportRes apiBrandReportGET(brandName, startDate, endDate, fields)

Get reports depends on brand name 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new ReportManagementApi();
var brandName = brandName_example; // String | Specify which brand's report to return
var startDate = startDate_example; // String | Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var endDate = endDate_example; // String | Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var fields = fields_example; // String | Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController

try { 
    var result = api_instance.apiBrandReportGET(brandName, startDate, endDate, fields);
    print(result);
} catch (e) {
    print("Exception when calling ReportManagementApi->apiBrandReportGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **brandName** | **String**| Specify which brand&#39;s report to return | 
 **startDate** | **String**| Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **endDate** | **String**| Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **fields** | **String**| Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController | [optional] 

### Return type

[**ReportRes**](ReportRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiBrandTypeReportGET**
> ReportRes apiBrandTypeReportGET(brandName, typeEnum, startDate, endDate, fields)

Get reports depends on brand name and periodical type 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new ReportManagementApi();
var brandName = brandName_example; // String | Specify which brand's report to return
var typeEnum = typeEnum_example; // String | Specify which periodical type to return. e.g. daily, weekly, monthly...
var startDate = startDate_example; // String | Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var endDate = endDate_example; // String | Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var fields = fields_example; // String | Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController

try { 
    var result = api_instance.apiBrandTypeReportGET(brandName, typeEnum, startDate, endDate, fields);
    print(result);
} catch (e) {
    print("Exception when calling ReportManagementApi->apiBrandTypeReportGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **brandName** | **String**| Specify which brand&#39;s report to return | 
 **typeEnum** | **String**| Specify which periodical type to return. e.g. daily, weekly, monthly... | 
 **startDate** | **String**| Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **endDate** | **String**| Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **fields** | **String**| Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController | [optional] 

### Return type

[**ReportRes**](ReportRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiReportGET**
> ReportRes apiReportGET(startDate, endDate, fields)

Get reports 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new ReportManagementApi();
var startDate = startDate_example; // String | Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var endDate = endDate_example; // String | Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime)
var fields = fields_example; // String | Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController

try { 
    var result = api_instance.apiReportGET(startDate, endDate, fields);
    print(result);
} catch (e) {
    print("Exception when calling ReportManagementApi->apiReportGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **String**| Specify when the returned reports start from. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **endDate** | **String**| Specify when the returned reports end. e.g. YYYY-MM-DDThh:mm:ssTZD(https://www.w3.org/TR/NOTE-datetime) | [optional] 
 **fields** | **String**| Specify which supported field of reports to return. Concatenate with comma for mutiple requirement. e.g. controller,activeController | [optional] 

### Return type

[**ReportRes**](ReportRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiReportSupportFieldsGET**
> ReportSupportFieldsRes apiReportSupportFieldsGET()

Get support fields of report 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new ReportManagementApi();

try { 
    var result = api_instance.apiReportSupportFieldsGET();
    print(result);
} catch (e) {
    print("Exception when calling ReportManagementApi->apiReportSupportFieldsGET: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ReportSupportFieldsRes**](ReportSupportFieldsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

