# swagger.api.RuleManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiControllerRuleDELETE**](RuleManagementApi.md#apiControllerRuleDELETE) | **DELETE** /api/1/controllers/{controllerId}/rules | Delete a controller&#39;s rules 
[**apiControllerRulePATCH**](RuleManagementApi.md#apiControllerRulePATCH) | **PATCH** /api/1/controllers/{controllerId}/rules | Update a controller&#39;s rules 
[**apiControllerRulePOST**](RuleManagementApi.md#apiControllerRulePOST) | **POST** /api/1/controllers/{controllerId}/rules | Add a controller&#39;s rules 
[**apiControllerRuleTrigger**](RuleManagementApi.md#apiControllerRuleTrigger) | **POST** /api/1/controllers/{controllerId}/rules/{ruleId}/trigger | Trigger a controller&#39;s rule manually 
[**apiControllerRulessGET**](RuleManagementApi.md#apiControllerRulessGET) | **GET** /api/1/controllers/{controllerId}/rules | Get a controller&#39;s rules 
[**apiRulesGET**](RuleManagementApi.md#apiRulesGET) | **GET** /api/1/rules/ | Get all rules of all controllers 


# **apiControllerRuleDELETE**
> OperRulesRes apiControllerRuleDELETE(controllerId, ruleId, body)

Delete a controller's rules 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var controllerId = controllerId_example; // String | controller id
var ruleId = ruleId_example; // String | rule id
var body = new RuleIdList(); // RuleIdList | 

try { 
    var result = api_instance.apiControllerRuleDELETE(controllerId, ruleId, body);
    print(result);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiControllerRuleDELETE: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **ruleId** | **String**| rule id | [optional] 
 **body** | [**RuleIdList**](RuleIdList.md)|  | [optional] 

### Return type

[**OperRulesRes**](OperRulesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerRulePATCH**
> OperRulesRes apiControllerRulePATCH(controllerId, body)

Update a controller's rules 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var controllerId = controllerId_example; // String | controller id
var body = new Rules(); // Rules | 

try { 
    var result = api_instance.apiControllerRulePATCH(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiControllerRulePATCH: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **body** | [**Rules**](Rules.md)|  | 

### Return type

[**OperRulesRes**](OperRulesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerRulePOST**
> OperRulesRes apiControllerRulePOST(controllerId, body)

Add a controller's rules 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var controllerId = controllerId_example; // String | controller id
var body = new Rules(); // Rules | 

try { 
    var result = api_instance.apiControllerRulePOST(controllerId, body);
    print(result);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiControllerRulePOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **body** | [**Rules**](Rules.md)|  | 

### Return type

[**OperRulesRes**](OperRulesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerRuleTrigger**
> apiControllerRuleTrigger(controllerId, ruleId)

Trigger a controller's rule manually 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var controllerId = controllerId_example; // String | controller id
var ruleId = ruleId_example; // String | rule id

try { 
    api_instance.apiControllerRuleTrigger(controllerId, ruleId);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiControllerRuleTrigger: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **ruleId** | **String**| rule id | 

### Return type

void (empty response body)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiControllerRulessGET**
> GetRulesRes apiControllerRulessGET(controllerId, ruleId, type)

Get a controller's rules 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var controllerId = controllerId_example; // String | controller id
var ruleId = ruleId_example; // String | rule id
var type = type_example; // String | return rules of this type

try { 
    var result = api_instance.apiControllerRulessGET(controllerId, ruleId, type);
    print(result);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiControllerRulessGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| controller id | 
 **ruleId** | **String**| rule id | [optional] 
 **type** | **String**| return rules of this type | [optional] [default to automation]

### Return type

[**GetRulesRes**](GetRulesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiRulesGET**
> GetUserRulesRes apiRulesGET(type)

Get all rules of all controllers 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new RuleManagementApi();
var type = type_example; // String | return rules of this type

try { 
    var result = api_instance.apiRulesGET(type);
    print(result);
} catch (e) {
    print("Exception when calling RuleManagementApi->apiRulesGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**| return rules of this type | [optional] [default to automation]

### Return type

[**GetUserRulesRes**](GetUserRulesRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

