# swagger.api.StreamingManagementApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiLiveViewGET**](StreamingManagementApi.md#apiLiveViewGET) | **GET** /api/1/controllers/{controllerId}/devices/{devId}/live/ | Request live view streaming from camera device 
[**apiPlaylistGET**](StreamingManagementApi.md#apiPlaylistGET) | **GET** /api/1/controllers/{controllerId}/devices/{devId}/playlist/ | Request playlist of recording from camera device 
[**apiSnapshotGET**](StreamingManagementApi.md#apiSnapshotGET) | **GET** /api/1/controllers/{controllerId}/devices/{devId}/snapshot/ | Request latest snapshot from camera device 
[**apiSnapshotPOST**](StreamingManagementApi.md#apiSnapshotPOST) | **POST** /api/1/controllers/{controllerId}/devices/{devId}/snapshot/ | Upload latest snapshot of camera device 
[**apiStreamingRecordsGET**](StreamingManagementApi.md#apiStreamingRecordsGET) | **GET** /api/1/controllers/{controllerId}/devices/{devId}/records/ | Retrive streaming records of camera in use 


# **apiLiveViewGET**
> StreamingUrlRes apiLiveViewGET(controllerId, devId)

Request live view streaming from camera device 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new StreamingManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 

try { 
    var result = api_instance.apiLiveViewGET(controllerId, devId);
    print(result);
} catch (e) {
    print("Exception when calling StreamingManagementApi->apiLiveViewGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 

### Return type

[**StreamingUrlRes**](StreamingUrlRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiPlaylistGET**
> StreamingUrlRes apiPlaylistGET(controllerId, devId, startTime, endTime)

Request playlist of recording from camera device 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new StreamingManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var startTime = 8.14; // num | Start time of recording on demand.
var endTime = 8.14; // num | End time of recording on demand.

try { 
    var result = api_instance.apiPlaylistGET(controllerId, devId, startTime, endTime);
    print(result);
} catch (e) {
    print("Exception when calling StreamingManagementApi->apiPlaylistGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **startTime** | **num**| Start time of recording on demand. | 
 **endTime** | **num**| End time of recording on demand. | 

### Return type

[**StreamingUrlRes**](StreamingUrlRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiSnapshotGET**
> GetSnapshotRes apiSnapshotGET(controllerId, devId)

Request latest snapshot from camera device 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new StreamingManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 

try { 
    var result = api_instance.apiSnapshotGET(controllerId, devId);
    print(result);
} catch (e) {
    print("Exception when calling StreamingManagementApi->apiSnapshotGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 

### Return type

[**GetSnapshotRes**](GetSnapshotRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiSnapshotPOST**
> StreamingUrlRes apiSnapshotPOST(controllerId, devId, file, width, height)

Upload latest snapshot of camera device 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new StreamingManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var file = /path/to/file.txt; // MultipartFile | file to upload
var width = 8.14; // num | width of uploading snapshot
var height = 8.14; // num | height of uploading snapshot

try { 
    var result = api_instance.apiSnapshotPOST(controllerId, devId, file, width, height);
    print(result);
} catch (e) {
    print("Exception when calling StreamingManagementApi->apiSnapshotPOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **file** | **MultipartFile**| file to upload | 
 **width** | **num**| width of uploading snapshot | [optional] 
 **height** | **num**| height of uploading snapshot | [optional] 

### Return type

[**StreamingUrlRes**](StreamingUrlRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiStreamingRecordsGET**
> GetStreamingRecordsRes apiStreamingRecordsGET(controllerId, devId, channel)

Retrive streaming records of camera in use 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new StreamingManagementApi();
var controllerId = controllerId_example; // String | 
var devId = devId_example; // String | 
var channel = channel_example; // String | 

try { 
    var result = api_instance.apiStreamingRecordsGET(controllerId, devId, channel);
    print(result);
} catch (e) {
    print("Exception when calling StreamingManagementApi->apiStreamingRecordsGET: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**|  | 
 **devId** | **String**|  | 
 **channel** | **String**|  | 

### Return type

[**GetStreamingRecordsRes**](GetStreamingRecordsRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

