# swagger.api.UtilityApi

## Load the API package
```dart
import 'package:swagger/api.dart';
```

All URIs are relative to *https://api.siterwell.co.uk*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiControllersFilePOST**](UtilityApi.md#apiControllersFilePOST) | **POST** /api/1/controllers/{controllerId}/files | upload file 
[**apiGeoIpGet**](UtilityApi.md#apiGeoIpGet) | **GET** /api/1/geoIp/ | Get geographic information from IP address 
[**apiGeoIpPost**](UtilityApi.md#apiGeoIpPost) | **POST** /api/1/geoIp/ | Add geographic information from mobile app 
[**apiGetTimezone**](UtilityApi.md#apiGetTimezone) | **GET** /api/1/timezone | Get timezone info 
[**apiGetVersion**](UtilityApi.md#apiGetVersion) | **GET** /api/1/version/ | Get server related version info 
[**apiGetWeather**](UtilityApi.md#apiGetWeather) | **GET** /api/1/weather | Get weather info 
[**apiUtilUploadFile**](UtilityApi.md#apiUtilUploadFile) | **POST** /api/1/upload/file | upload file 


# **apiControllersFilePOST**
> MessageRes apiControllersFilePOST(file, data, controllerId)

upload file 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var file = /path/to/file.txt; // MultipartFile | file to upload
var data = data_example; // String | data
var controllerId = controllerId_example; // String | controller id

try { 
    var result = api_instance.apiControllersFilePOST(file, data, controllerId);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiControllersFilePOST: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file** | **MultipartFile**| file to upload | 
 **data** | **String**| data | 
 **controllerId** | **String**| controller id | 

### Return type

[**MessageRes**](MessageRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGeoIpGet**
> GetGeoIpRes apiGeoIpGet(controllerId)

Get geographic information from IP address 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var controllerId = controllerId_example; // String | Update controller's location if its ID was assgined.

try { 
    var result = api_instance.apiGeoIpGet(controllerId);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiGeoIpGet: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controllerId** | **String**| Update controller&#39;s location if its ID was assgined. | [optional] 

### Return type

[**GetGeoIpRes**](GetGeoIpRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGeoIpPost**
> SuccessRes apiGeoIpPost(body)

Add geographic information from mobile app 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var body = new GeoItem(); // GeoItem | 

try { 
    var result = api_instance.apiGeoIpPost(body);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiGeoIpPost: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GeoItem**](GeoItem.md)|  | 

### Return type

[**SuccessRes**](SuccessRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGetTimezone**
> TimezoneRes apiGetTimezone(zip, country)

Get timezone info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var zip = zip_example; // String | zip code to query
var country = country_example; // String | country to query

try { 
    var result = api_instance.apiGetTimezone(zip, country);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiGetTimezone: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **zip** | **String**| zip code to query | [optional] 
 **country** | **String**| country to query | [optional] 

### Return type

[**TimezoneRes**](TimezoneRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGetVersion**
> GetVersionRes apiGetVersion()

Get server related version info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();

try { 
    var result = api_instance.apiGetVersion();
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiGetVersion: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**GetVersionRes**](GetVersionRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiGetWeather**
> WeatherRes apiGetWeather(type, zip, country, interval)

Get weather info 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var type = type_example; // String | current, hourly, daily
var zip = zip_example; // String | zip code to query
var country = country_example; // String | country to query
var interval = interval_example; // String | query interval

try { 
    var result = api_instance.apiGetWeather(type, zip, country, interval);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiGetWeather: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**| current, hourly, daily | [optional] 
 **zip** | **String**| zip code to query | [optional] 
 **country** | **String**| country to query | [optional] 
 **interval** | **String**| query interval | [optional] 

### Return type

[**WeatherRes**](WeatherRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **apiUtilUploadFile**
> MessageRes apiUtilUploadFile(file, data)

upload file 

### Example 
```dart
import 'package:swagger/api.dart';
// TODO Configure API key authorization: Token
//swagger.api.Configuration.apiKey{'Bearer'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Bearer'} = "Bearer";

var api_instance = new UtilityApi();
var file = /path/to/file.txt; // MultipartFile | file to upload
var data = data_example; // String | data

try { 
    var result = api_instance.apiUtilUploadFile(file, data);
    print(result);
} catch (e) {
    print("Exception when calling UtilityApi->apiUtilUploadFile: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file** | **MultipartFile**| file to upload | 
 **data** | **String**| data | 

### Return type

[**MessageRes**](MessageRes.md)

### Authorization

[Token](../README.md#Token)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

