library swagger.api;

import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart';

part 'api_client.dart';
part 'api_helper.dart';
part 'api_exception.dart';
part 'auth/authentication.dart';
part 'auth/api_key_auth.dart';
part 'auth/oauth.dart';
part 'auth/http_basic_auth.dart';

part 'api/account_management_api.dart';
part 'api/device_management_api.dart';
part 'api/event_handle_api.dart';
part 'api/family_account_management_api.dart';
part 'api/log_management_api.dart';
part 'api/report_management_api.dart';
part 'api/rule_management_api.dart';
part 'api/streaming_management_api.dart';
part 'api/utility_api.dart';

part 'model/action_item.dart';
part 'model/alert_res.dart';
part 'model/caps_group_item.dart';
part 'model/condition_item.dart';
part 'model/controller_ctrl_req.dart';
part 'model/controller_ctrl_req_params.dart';
part 'model/controller_item.dart';
part 'model/controller_item_res.dart';
part 'model/ctrl_item.dart';
part 'model/defined_event_item.dart';
part 'model/defined_event_trans_item.dart';
part 'model/defined_events_res.dart';
part 'model/defined_events_res_results.dart';
part 'model/defined_privileges_item.dart';
part 'model/defined_privileges_res.dart';
part 'model/defined_privileges_res_results.dart';
part 'model/dev_channel_item.dart';
part 'model/dev_property_item.dart';
part 'model/device_item.dart';
part 'model/device_item_res.dart';
part 'model/dnd_item.dart';
part 'model/error_res.dart';
part 'model/event_item.dart';
part 'model/forgot_password_req.dart';
part 'model/geo_item.dart';
part 'model/get_controllers_res.dart';
part 'model/get_controllers_res_results.dart';
part 'model/get_devices_res.dart';
part 'model/get_devices_res_results.dart';
part 'model/get_geo_ip_res.dart';
part 'model/get_geo_ip_res_results.dart';
part 'model/get_logs_res.dart';
part 'model/get_rules_res.dart';
part 'model/get_rules_res_results.dart';
part 'model/get_snapshot_res.dart';
part 'model/get_streaming_records_res.dart';
part 'model/get_user_rules_res.dart';
part 'model/get_user_rules_res_results.dart';
part 'model/get_users_rules_item.dart';
part 'model/get_version_res.dart';
part 'model/get_version_res_results.dart';
part 'model/group_item.dart';
part 'model/hw_info_item.dart';
part 'model/inline_response200.dart';
part 'model/log_item.dart';
part 'model/log_item_content.dart';
part 'model/login_req.dart';
part 'model/message_res.dart';
part 'model/mode_item.dart';
part 'model/oper_dev_item_res.dart';
part 'model/oper_devices_res.dart';
part 'model/oper_devices_res_results.dart';
part 'model/oper_rule_item_res.dart';
part 'model/oper_rules_res.dart';
part 'model/oper_rules_res_results.dart';
part 'model/parm_item.dart';
part 'model/parm_item_array.dart';
part 'model/parm_item_array_inner.dart';
part 'model/place_item.dart';
part 'model/post_snapshot_res.dart';
part 'model/privilege_item.dart';
part 'model/privilege_item_in.dart';
part 'model/privilege_item_priv_group.dart';
part 'model/property_item.dart';
part 'model/register_req.dart';
part 'model/report_item.dart';
part 'model/report_res.dart';
part 'model/report_support_fields_res.dart';
part 'model/reset_password_req.dart';
part 'model/rule_id_list.dart';
part 'model/rule_id_list_inner.dart';
part 'model/rule_item.dart';
part 'model/rules.dart';
part 'model/simply_event_item.dart';
part 'model/snapshot_item.dart';
part 'model/status_item.dart';
part 'model/streaming_record_item.dart';
part 'model/streaming_url_res.dart';
part 'model/success_res.dart';
part 'model/timezone_res.dart';
part 'model/timezone_res_results.dart';
part 'model/user_data_item.dart';
part 'model/user_data_req.dart';
part 'model/user_item.dart';
part 'model/user_me_res.dart';
part 'model/weather_item.dart';
part 'model/weather_item_main.dart';
part 'model/weather_item_main_temp.dart';
part 'model/weather_item_weather.dart';
part 'model/weather_res.dart';
part 'model/weather_res_errors.dart';


ApiClient defaultApiClient = new ApiClient();
