part of swagger.api;



class DeviceManagementApi {
  final ApiClient apiClient;

  DeviceManagementApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Control a controller 
  ///
  /// 
  Future<SuccessRes> apiControllerCtrlPOST(String controllerId, ControllerCtrlReq body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/ctrl/".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Delete a controller 
  ///
  /// 
  Future<SuccessRes> apiControllerDELETE(String controllerId) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Get controller info 
  ///
  /// 
  Future<GetControllersRes> apiControllerGET({ String controllerId }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/controllers".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(controllerId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetControllersRes') as GetControllersRes ;
    } else {
      return null;
    }
  }
  /// Update a controller 
  ///
  /// 
  Future<SuccessRes> apiControllerPATCH(ControllerItem body, { String time, String controllerId }) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    if(controllerId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PATCH',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Add a controller 
  ///
  /// 
  Future<SuccessRes> apiControllerPOST(ControllerItem body, { String time, String controllerId }) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    if(controllerId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Put a controller 
  ///
  /// 
  Future<SuccessRes> apiControllerPUT(ControllerItem body, { String time, String controllerId }) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    if(controllerId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PUT',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Control a channel of a specified device property 
  ///
  /// 
  Future<SuccessRes> apiDeviceChannelCtrlPOST(String controllerId, String devId, String channelId, CtrlItem body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(devId == null) {
     throw new ApiException(400, "Missing required param: devId");
    }
    if(channelId == null) {
     throw new ApiException(400, "Missing required param: channelId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices/{devId}/channels/{channelId}/ctrl/".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "devId" + "}", devId.toString()).replaceAll("{" + "channelId" + "}", channelId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Control a device property 
  ///
  /// 
  Future<SuccessRes> apiDeviceCtrlPOST(String controllerId, String devId, CtrlItem body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(devId == null) {
     throw new ApiException(400, "Missing required param: devId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices/{devId}/ctrl/".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "devId" + "}", devId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Delete a controller&#39;s devices 
  ///
  /// 
  Future<SuccessRes> apiDevicesDELETE(String controllerId, { String devId }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(devId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "devId", devId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Get devices info 
  ///
  /// 
  Future<GetDevicesRes> apiDevicesGet(String controllerId, { String devId }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(devId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "devId", devId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetDevicesRes') as GetDevicesRes ;
    } else {
      return null;
    }
  }
  /// Update a controller&#39;s devices 
  ///
  /// 
  Future<OperDevicesRes> apiDevicesPATCH(String controllerId, List<DeviceItem> body, { String time }) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PATCH',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperDevicesRes') as OperDevicesRes ;
    } else {
      return null;
    }
  }
  /// Add a controller&#39;s devices 
  ///
  /// 
  Future<OperDevicesRes> apiDevicesPOST(String controllerId, List<DeviceItem> body, { String time }) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperDevicesRes') as OperDevicesRes ;
    } else {
      return null;
    }
  }
  /// Put a controller&#39;s devices 
  ///
  /// 
  Future<OperDevicesRes> apiDevicesPUT(String controllerId, List<DeviceItem> body, { String time }) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(time != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PUT',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperDevicesRes') as OperDevicesRes ;
    } else {
      return null;
    }
  }
  /// Get timezone info 
  ///
  /// 
  Future<TimezoneRes> apiGetControllerTimezone(String controllerId, { String zip, String country }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/timezone".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(zip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "zip", zip));
    }
    if(country != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "country", country));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'TimezoneRes') as TimezoneRes ;
    } else {
      return null;
    }
  }
  /// Get weather info 
  ///
  /// 
  Future<WeatherRes> apiGetControllerWeather(String controllerId, { String type, String country, String zip, String interval }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/weather".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(type != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    }
    if(country != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "country", country));
    }
    if(zip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "zip", zip));
    }
    if(interval != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "interval", interval));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'WeatherRes') as WeatherRes ;
    } else {
      return null;
    }
  }
}
