part of swagger.api;



class EventHandleApi {
  final ApiClient apiClient;

  EventHandleApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// alert handle 
  ///
  /// 
  Future<AlertRes> apiAlert(String controllerId, List<LogItem> body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/event/controllers/{controllerId}/alert".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'AlertRes') as AlertRes ;
    } else {
      return null;
    }
  }
  /// Batch handle event
  ///
  /// 
  Future<MessageRes> apiBatchHandlePOST(String controllerId, String type, String group, List<SimplyEventItem> body, { bool notifyController }) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(type == null) {
     throw new ApiException(400, "Missing required param: type");
    }
    if(group == null) {
     throw new ApiException(400, "Missing required param: group");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/event/controllers/{controllerId}/batchHandle".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
      queryParams.addAll(_convertParametersForCollectionFormat("", "group", group));
    if(notifyController != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "notifyController", notifyController));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'MessageRes') as MessageRes ;
    } else {
      return null;
    }
  }
  /// event trigger 
  ///
  /// 
  Future<DefinedEventsRes> apiEventDefGET() async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/event/def/".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'DefinedEventsRes') as DefinedEventsRes ;
    } else {
      return null;
    }
  }
  /// event trigger 
  ///
  /// 
  Future<MessageRes> apiEventHandle(EventItem body) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/event/handle".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'MessageRes') as MessageRes ;
    } else {
      return null;
    }
  }
  /// Handle event with file
  ///
  /// 
  Future<SuccessRes> apiHandleFilePOST(String controllerId, String devId, String time, String type, MultipartFile file, String data) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(devId == null) {
     throw new ApiException(400, "Missing required param: devId");
    }
    if(time == null) {
     throw new ApiException(400, "Missing required param: time");
    }
    if(type == null) {
     throw new ApiException(400, "Missing required param: type");
    }
    if(file == null) {
     throw new ApiException(400, "Missing required param: file");
    }
    if(data == null) {
     throw new ApiException(400, "Missing required param: data");
    }

    // create path and map variables
    String path = "/api/1/event/controllers/{controllerId}/devices/{devId}/file".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "devId" + "}", devId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    
    List<String> contentTypes = ["multipart/form-data"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if (file != null) {
        hasFields = true;
        mp.fields['file'] = file.field;
        mp.files.add(file);
      }
      
      if (data != null) {
        hasFields = true;
        mp.fields['data'] = parameterToString(data);
      }
      
      if(hasFields)
        postBody = mp;
    }
    else {
      
if (data != null)
        formParams['data'] = parameterToString(data);
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
}
