part of swagger.api;



class LogManagementApi {
  final ApiClient apiClient;

  LogManagementApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Get all controller logs by user 
  ///
  /// 
  Future<GetLogsRes> api1LogsGet({ num limit, num offset, String logType, String startTime, String endTime, String startCreatedAt, String endCreatedAt, bool getTotal }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/logs".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(logType != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "logType", logType));
    }
    if(startTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startTime", startTime));
    }
    if(endTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endTime", endTime));
    }
    if(startCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startCreatedAt", startCreatedAt));
    }
    if(endCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endCreatedAt", endCreatedAt));
    }
    if(getTotal != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "getTotal", getTotal));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetLogsRes') as GetLogsRes ;
    } else {
      return null;
    }
  }
  /// Get a controller&#39;s logs 
  ///
  /// 
  Future<GetLogsRes> apiControllerLogsGET(String controllerId, { num limit, num offset, String logType, String startTime, String endTime, String startCreatedAt, String endCreatedAt, bool getTotal }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/logs".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(logType != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "logType", logType));
    }
    if(startTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startTime", startTime));
    }
    if(endTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endTime", endTime));
    }
    if(startCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startCreatedAt", startCreatedAt));
    }
    if(endCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endCreatedAt", endCreatedAt));
    }
    if(getTotal != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "getTotal", getTotal));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetLogsRes') as GetLogsRes ;
    } else {
      return null;
    }
  }
  /// Get a device&#39;s logs 
  ///
  /// 
  Future<GetLogsRes> apiDeviceLogsGET(String controllerId, String devId, { num limit, num offset, String logType, String startTime, String endTime, String startCreatedAt, String endCreatedAt, bool getTotal }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(devId == null) {
     throw new ApiException(400, "Missing required param: devId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/devices/{devId}/logs".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "devId" + "}", devId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(logType != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "logType", logType));
    }
    if(startTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startTime", startTime));
    }
    if(endTime != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endTime", endTime));
    }
    if(startCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "startCreatedAt", startCreatedAt));
    }
    if(endCreatedAt != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "endCreatedAt", endCreatedAt));
    }
    if(getTotal != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "getTotal", getTotal));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetLogsRes') as GetLogsRes ;
    } else {
      return null;
    }
  }
  /// sync logs 
  ///
  /// 
  Future<GetLogsRes> apiSyncLogs(List<LogItem> body, { String end }) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/logs/sync".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(end != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "end", end));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetLogsRes') as GetLogsRes ;
    } else {
      return null;
    }
  }
  /// Sync logs with snapshot  
  ///
  /// 
  Future<SuccessRes> apiSyncSnapshotPOST(String controllerId, String devId, String end, String time, MultipartFile file, String data) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(devId == null) {
     throw new ApiException(400, "Missing required param: devId");
    }
    if(end == null) {
     throw new ApiException(400, "Missing required param: end");
    }
    if(time == null) {
     throw new ApiException(400, "Missing required param: time");
    }
    if(file == null) {
     throw new ApiException(400, "Missing required param: file");
    }
    if(data == null) {
     throw new ApiException(400, "Missing required param: data");
    }

    // create path and map variables
    String path = "/api/1/logs/controllers/{controllerId}/devices/{devId}/sync/snapshot/".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "devId" + "}", devId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "end", end));
      queryParams.addAll(_convertParametersForCollectionFormat("", "time", time));
    
    List<String> contentTypes = ["multipart/form-data"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if (file != null) {
        hasFields = true;
        mp.fields['file'] = file.field;
        mp.files.add(file);
      }
      
      if (data != null) {
        hasFields = true;
        mp.fields['data'] = parameterToString(data);
      }
      
      if(hasFields)
        postBody = mp;
    }
    else {
      
if (data != null)
        formParams['data'] = parameterToString(data);
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
}
