part of swagger.api;



class RuleManagementApi {
  final ApiClient apiClient;

  RuleManagementApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Delete a controller&#39;s rules 
  ///
  /// 
  Future<OperRulesRes> apiControllerRuleDELETE(String controllerId, { String ruleId, RuleIdList body }) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/rules".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(ruleId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "ruleId", ruleId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperRulesRes') as OperRulesRes ;
    } else {
      return null;
    }
  }
  /// Update a controller&#39;s rules 
  ///
  /// 
  Future<OperRulesRes> apiControllerRulePATCH(String controllerId, Rules body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/rules".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PATCH',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperRulesRes') as OperRulesRes ;
    } else {
      return null;
    }
  }
  /// Add a controller&#39;s rules 
  ///
  /// 
  Future<OperRulesRes> apiControllerRulePOST(String controllerId, Rules body) async {
    Object postBody = body;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/rules".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'OperRulesRes') as OperRulesRes ;
    } else {
      return null;
    }
  }
  /// Trigger a controller&#39;s rule manually 
  ///
  /// 
  Future apiControllerRuleTrigger(String controllerId, String ruleId) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }
    if(ruleId == null) {
     throw new ApiException(400, "Missing required param: ruleId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/rules/{ruleId}/trigger".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString()).replaceAll("{" + "ruleId" + "}", ruleId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          ;
    } else {
      return ;
    }
  }
  /// Get a controller&#39;s rules 
  ///
  /// 
  Future<GetRulesRes> apiControllerRulessGET(String controllerId, { String ruleId, String type }) async {
    Object postBody = null;

    // verify required params are set
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/rules".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(ruleId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "ruleId", ruleId));
    }
    if(type != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetRulesRes') as GetRulesRes ;
    } else {
      return null;
    }
  }
  /// Get all rules of all controllers 
  ///
  /// 
  Future<GetUserRulesRes> apiRulesGET({ String type }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/rules/".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(type != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetUserRulesRes') as GetUserRulesRes ;
    } else {
      return null;
    }
  }
}
