part of swagger.api;



class UtilityApi {
  final ApiClient apiClient;

  UtilityApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// upload file 
  ///
  /// 
  Future<MessageRes> apiControllersFilePOST(MultipartFile file, String data, String controllerId) async {
    Object postBody = null;

    // verify required params are set
    if(file == null) {
     throw new ApiException(400, "Missing required param: file");
    }
    if(data == null) {
     throw new ApiException(400, "Missing required param: data");
    }
    if(controllerId == null) {
     throw new ApiException(400, "Missing required param: controllerId");
    }

    // create path and map variables
    String path = "/api/1/controllers/{controllerId}/files".replaceAll("{format}","json").replaceAll("{" + "controllerId" + "}", controllerId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["multipart/form-data"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if (file != null) {
        hasFields = true;
        mp.fields['file'] = file.field;
        mp.files.add(file);
      }
      
      if (data != null) {
        hasFields = true;
        mp.fields['data'] = parameterToString(data);
      }
      
      if(hasFields)
        postBody = mp;
    }
    else {
      
if (data != null)
        formParams['data'] = parameterToString(data);
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'MessageRes') as MessageRes ;
    } else {
      return null;
    }
  }
  /// Get geographic information from IP address 
  ///
  /// 
  Future<GetGeoIpRes> apiGeoIpGet({ String controllerId }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/geoIp/".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(controllerId != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "controllerId", controllerId));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetGeoIpRes') as GetGeoIpRes ;
    } else {
      return null;
    }
  }
  /// Add geographic information from mobile app 
  ///
  /// 
  Future<SuccessRes> apiGeoIpPost(GeoItem body) async {
    Object postBody = body;

    // verify required params are set
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/api/1/geoIp/".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'SuccessRes') as SuccessRes ;
    } else {
      return null;
    }
  }
  /// Get timezone info 
  ///
  /// 
  Future<TimezoneRes> apiGetTimezone({ String zip, String country }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/timezone".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(zip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "zip", zip));
    }
    if(country != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "country", country));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'TimezoneRes') as TimezoneRes ;
    } else {
      return null;
    }
  }
  /// Get server related version info 
  ///
  /// 
  Future<GetVersionRes> apiGetVersion() async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/version/".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'GetVersionRes') as GetVersionRes ;
    } else {
      return null;
    }
  }
  /// Get weather info 
  ///
  /// 
  Future<WeatherRes> apiGetWeather({ String type, String zip, String country, String interval }) async {
    Object postBody = null;

    // verify required params are set

    // create path and map variables
    String path = "/api/1/weather".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(type != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    }
    if(zip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "zip", zip));
    }
    if(country != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "country", country));
    }
    if(interval != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "interval", interval));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'WeatherRes') as WeatherRes ;
    } else {
      return null;
    }
  }
  /// upload file 
  ///
  /// 
  Future<MessageRes> apiUtilUploadFile(MultipartFile file, String data) async {
    Object postBody = null;

    // verify required params are set
    if(file == null) {
     throw new ApiException(400, "Missing required param: file");
    }
    if(data == null) {
     throw new ApiException(400, "Missing required param: data");
    }

    // create path and map variables
    String path = "/api/1/upload/file".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    
    List<String> contentTypes = ["multipart/form-data"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["Token"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if (file != null) {
        hasFields = true;
        mp.fields['file'] = file.field;
        mp.files.add(file);
      }
      
      if (data != null) {
        hasFields = true;
        mp.fields['data'] = parameterToString(data);
      }
      
      if(hasFields)
        postBody = mp;
    }
    else {
      
if (data != null)
        formParams['data'] = parameterToString(data);
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'MessageRes') as MessageRes ;
    } else {
      return null;
    }
  }
}
