part of swagger.api;

class QueryParam {
  String name;
  String value;

  QueryParam(this.name, this.value);
}

class ApiClient {

  String basePath;
  var client = new Client();

  Map<String, String> _defaultHeaderMap = {};
  Map<String, Authentication> _authentications = {};

  final _RegList = new RegExp(r'^List<(.*)>$');
  final _RegMap = new RegExp(r'^Map<String,(.*)>$');

  ApiClient({this.basePath: "https://api.siterwell.co.uk"}) {
    // Setup authentications (key: authentication name, value: authentication).
    _authentications['Token'] = new ApiKeyAuth("header", "Bearer");
  }

  void addDefaultHeader(String key, String value) {
     _defaultHeaderMap[key] = value;
  }

  dynamic _deserialize(dynamic value, String targetType) {
    try {
      switch (targetType) {
        case 'String':
          return '$value';
        case 'int':
          return value is int ? value : int.parse('$value');
        case 'bool':
          return value is bool ? value : '$value'.toLowerCase() == 'true';
        case 'double':
          return value is double ? value : double.parse('$value');
        case 'ActionItem':
          return new ActionItem.fromJson(value);
        case 'AlertRes':
          return new AlertRes.fromJson(value);
        case 'CapsGroupItem':
          return new CapsGroupItem.fromJson(value);
        case 'ConditionItem':
          return new ConditionItem.fromJson(value);
        case 'ControllerCtrlReq':
          return new ControllerCtrlReq.fromJson(value);
        case 'ControllerCtrlReqParams':
          return new ControllerCtrlReqParams.fromJson(value);
        case 'ControllerItem':
          return new ControllerItem.fromJson(value);
        case 'ControllerItemRes':
          return new ControllerItemRes.fromJson(value);
        case 'CtrlItem':
          return new CtrlItem.fromJson(value);
        case 'DefinedEventItem':
          return new DefinedEventItem.fromJson(value);
        case 'DefinedEventTransItem':
          return new DefinedEventTransItem.fromJson(value);
        case 'DefinedEventsRes':
          return new DefinedEventsRes.fromJson(value);
        case 'DefinedEventsResResults':
          return new DefinedEventsResResults.fromJson(value);
        case 'DefinedPrivilegesItem':
          return new DefinedPrivilegesItem.fromJson(value);
        case 'DefinedPrivilegesRes':
          return new DefinedPrivilegesRes.fromJson(value);
        case 'DefinedPrivilegesResResults':
          return new DefinedPrivilegesResResults.fromJson(value);
        case 'DevChannelItem':
          return new DevChannelItem.fromJson(value);
        case 'DevPropertyItem':
          return new DevPropertyItem.fromJson(value);
        case 'DeviceItem':
          return new DeviceItem.fromJson(value);
        case 'DeviceItemRes':
          return new DeviceItemRes.fromJson(value);
        case 'DndItem':
          return new DndItem.fromJson(value);
        case 'ErrorRes':
          return new ErrorRes.fromJson(value);
        case 'EventItem':
          return new EventItem.fromJson(value);
        case 'ForgotPasswordReq':
          return new ForgotPasswordReq.fromJson(value);
        case 'GeoItem':
          return new GeoItem.fromJson(value);
        case 'GetControllersRes':
          return new GetControllersRes.fromJson(value);
        case 'GetControllersResResults':
          return new GetControllersResResults.fromJson(value);
        case 'GetDevicesRes':
          return new GetDevicesRes.fromJson(value);
        case 'GetDevicesResResults':
          return new GetDevicesResResults.fromJson(value);
        case 'GetGeoIpRes':
          return new GetGeoIpRes.fromJson(value);
        case 'GetGeoIpResResults':
          return new GetGeoIpResResults.fromJson(value);
        case 'GetLogsRes':
          return new GetLogsRes.fromJson(value);
        case 'GetRulesRes':
          return new GetRulesRes.fromJson(value);
        case 'GetRulesResResults':
          return new GetRulesResResults.fromJson(value);
        case 'GetSnapshotRes':
          return new GetSnapshotRes.fromJson(value);
        case 'GetStreamingRecordsRes':
          return new GetStreamingRecordsRes.fromJson(value);
        case 'GetUserRulesRes':
          return new GetUserRulesRes.fromJson(value);
        case 'GetUserRulesResResults':
          return new GetUserRulesResResults.fromJson(value);
        case 'GetUsersRulesItem':
          return new GetUsersRulesItem.fromJson(value);
        case 'GetVersionRes':
          return new GetVersionRes.fromJson(value);
        case 'GetVersionResResults':
          return new GetVersionResResults.fromJson(value);
        case 'GroupItem':
          return new GroupItem.fromJson(value);
        case 'HwInfoItem':
          return new HwInfoItem.fromJson(value);
        case 'InlineResponse200':
          return new InlineResponse200.fromJson(value);
        case 'LogItem':
          return new LogItem.fromJson(value);
        case 'LogItemContent':
          return new LogItemContent.fromJson(value);
        case 'LoginReq':
          return new LoginReq.fromJson(value);
        case 'MessageRes':
          return new MessageRes.fromJson(value);
        case 'ModeItem':
          return new ModeItem.fromJson(value);
        case 'OperDevItemRes':
          return new OperDevItemRes.fromJson(value);
        case 'OperDevicesRes':
          return new OperDevicesRes.fromJson(value);
        case 'OperDevicesResResults':
          return new OperDevicesResResults.fromJson(value);
        case 'OperRuleItemRes':
          return new OperRuleItemRes.fromJson(value);
        case 'OperRulesRes':
          return new OperRulesRes.fromJson(value);
        case 'OperRulesResResults':
          return new OperRulesResResults.fromJson(value);
        case 'ParmItem':
          return new ParmItem.fromJson(value);
        case 'ParmItemArray':
          return new ParmItemArray.fromJson(value);
        case 'ParmItemArrayInner':
          return new ParmItemArrayInner.fromJson(value);
        case 'PlaceItem':
          return new PlaceItem.fromJson(value);
        case 'PostSnapshotRes':
          return new PostSnapshotRes.fromJson(value);
        case 'PrivilegeItem':
          return new PrivilegeItem.fromJson(value);
        case 'PrivilegeItemIn':
          return new PrivilegeItemIn.fromJson(value);
        case 'PrivilegeItemPrivGroup':
          return new PrivilegeItemPrivGroup.fromJson(value);
        case 'PropertyItem':
          return new PropertyItem.fromJson(value);
        case 'RegisterReq':
          return new RegisterReq.fromJson(value);
        case 'ReportItem':
          return new ReportItem.fromJson(value);
        case 'ReportRes':
          return new ReportRes.fromJson(value);
        case 'ReportSupportFieldsRes':
          return new ReportSupportFieldsRes.fromJson(value);
        case 'ResetPasswordReq':
          return new ResetPasswordReq.fromJson(value);
        case 'RuleIdList':
          return new RuleIdList.fromJson(value);
        case 'RuleIdListInner':
          return new RuleIdListInner.fromJson(value);
        case 'RuleItem':
          return new RuleItem.fromJson(value);
        case 'Rules':
          return new Rules.fromJson(value);
        case 'SimplyEventItem':
          return new SimplyEventItem.fromJson(value);
        case 'SnapshotItem':
          return new SnapshotItem.fromJson(value);
        case 'StatusItem':
          return new StatusItem.fromJson(value);
        case 'StreamingRecordItem':
          return new StreamingRecordItem.fromJson(value);
        case 'StreamingUrlRes':
          return new StreamingUrlRes.fromJson(value);
        case 'SuccessRes':
          return new SuccessRes.fromJson(value);
        case 'TimezoneRes':
          return new TimezoneRes.fromJson(value);
        case 'TimezoneResResults':
          return new TimezoneResResults.fromJson(value);
        case 'UserDataItem':
          return new UserDataItem.fromJson(value);
        case 'UserDataReq':
          return new UserDataReq.fromJson(value);
        case 'UserItem':
          return new UserItem.fromJson(value);
        case 'UserMeRes':
          return new UserMeRes.fromJson(value);
        case 'WeatherItem':
          return new WeatherItem.fromJson(value);
        case 'WeatherItemMain':
          return new WeatherItemMain.fromJson(value);
        case 'WeatherItemMainTemp':
          return new WeatherItemMainTemp.fromJson(value);
        case 'WeatherItemWeather':
          return new WeatherItemWeather.fromJson(value);
        case 'WeatherRes':
          return new WeatherRes.fromJson(value);
        case 'WeatherResErrors':
          return new WeatherResErrors.fromJson(value);
        default:
          {
            Match match;
            if (value is List &&
                (match = _RegList.firstMatch(targetType)) != null) {
              var newTargetType = match[1];
              return value.map((v) => _deserialize(v, newTargetType)).toList();
            } else if (value is Map &&
                (match = _RegMap.firstMatch(targetType)) != null) {
              var newTargetType = match[1];
              return new Map.fromIterables(value.keys,
                  value.values.map((v) => _deserialize(v, newTargetType)));
            }
          }
      }
    } catch (e, stack) {
      throw new ApiException.withInner(500, 'Exception during deserialization.', e, stack);
    }
    throw new ApiException(500, 'Could not find a suitable class for deserialization');
  }

  dynamic deserialize(String jsonVal, String targetType) {
    // Remove all spaces.  Necessary for reg expressions as well.
    targetType = targetType.replaceAll(' ', '');

    if (targetType == 'String') return jsonVal;

    var decodedJson = json.decode(jsonVal);
    return _deserialize(decodedJson, targetType);
  }

  String serialize(Object obj) {
    String serialized = '';
    if (obj == null) {
      serialized = '';
    } else {
      serialized = json.encode(obj);
    }
    return serialized;
  }

  // We don't use a Map<String, String> for queryParams.
  // If collectionFormat is 'multi' a key might appear multiple times.
  Future<Response> invokeAPI(String path,
                             String method,
                             Iterable<QueryParam> queryParams,
                             Object body,
                             Map<String, String> headerParams,
                             Map<String, String> formParams,
                             String contentType,
                             List<String> authNames) async {

    _updateParamsForAuth(authNames, queryParams, headerParams);

    var ps = queryParams.where((p) => p.value != null).map((p) => '${p.name}=${p.value}');
    String queryString = ps.isNotEmpty ?
                         '?' + ps.join('&') :
                         '';

    String url = basePath + path + queryString;

    headerParams.addAll(_defaultHeaderMap);
    headerParams['Content-Type'] = contentType;

    if(body is MultipartRequest) {
      var request = new MultipartRequest(method, Uri.parse(url));
      request.fields.addAll(body.fields);
      request.files.addAll(body.files);
      request.headers.addAll(body.headers);
      request.headers.addAll(headerParams);
      var response = await client.send(request);
      return Response.fromStream(response);
    } else {
      var msgBody = contentType == "application/x-www-form-urlencoded" ? formParams : serialize(body);
      switch(method) {
        case "POST":
          return client.post(url, headers: headerParams, body: msgBody);
        case "PUT":
          return client.put(url, headers: headerParams, body: msgBody);
        case "DELETE":
          return client.delete(url, headers: headerParams);
        case "PATCH":
          return client.patch(url, headers: headerParams, body: msgBody);
        default:
          return client.get(url, headers: headerParams);
      }
    }
  }

  /// Update query and header parameters based on authentication settings.
  /// @param authNames The authentications to apply
  void _updateParamsForAuth(List<String> authNames, List<QueryParam> queryParams, Map<String, String> headerParams) {
    authNames.forEach((authName) {
      Authentication auth = _authentications[authName];
      if (auth == null) throw new ArgumentError("Authentication undefined: " + authName);
      auth.applyToParams(queryParams, headerParams);
    });
  }

  void setAccessToken(String accessToken) {
    _authentications.forEach((key, auth) {
      if (auth is OAuth) {
        auth.setAccessToken(accessToken);
      }
    });
  }
}
