part of swagger.api;

class ControllerItem {
  /* Controller id */
  String controllerId = null;
  
/* Controller name */
  String name = null;
  
/* 0 - Tablet is Online, 1 - Tablet is Offline, 2 - User logout */
  String active = null;
  
/* Controller capability http://web.siterwell.co.uk/api/apiDoc.html#controller_cap */
  List<String> caps = [];
  

  List<ModeItem> modes = [];
  

  List<GroupItem> groups = [];
  

  List<PlaceItem> places = [];
  

  List<DevPropertyItem> props = [];
  

  List<HwInfoItem> hwInfo = [];
  

  List<DeviceItem> devices = [];
  
  ControllerItem();

  @override
  String toString() {
    return 'ControllerItem[controllerId=$controllerId, name=$name, active=$active, caps=$caps, modes=$modes, groups=$groups, places=$places, props=$props, hwInfo=$hwInfo, devices=$devices, ]';
  }

  ControllerItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    controllerId =
        json['controllerId']
    ;
    name =
        json['name']
    ;
    active =
        json['active']
    ;
    caps =
      //[Martin] Check Array size 0 and null 
        (json['caps'].toString()== '[]'||json['caps']== null) ? null : (json['caps'] as List).map((item) => item as String).toList()
    ;
    modes =
      ModeItem.listFromJson(json['modes'])
;
    groups =
      GroupItem.listFromJson(json['groups'])
;
    places =
      PlaceItem.listFromJson(json['places'])
;
    props =
      DevPropertyItem.listFromJson(json['props'])
;
    hwInfo =
      HwInfoItem.listFromJson(json['hwInfo'])
;
    devices =
      DeviceItem.listFromJson(json['devices'])
;
  }

  Map<String, dynamic> toJson() {
    return {
      'controllerId': controllerId,
      'name': name,
      'active': active,
      'caps': caps,
      'modes': modes,
      'groups': groups,
      'places': places,
      'props': props,
      'hwInfo': hwInfo,
      'devices': devices
     };
  }

  static List<ControllerItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<ControllerItem>();
    }
    return json.map((value) => new ControllerItem.fromJson(value)).toList();
  }

  static Map<String, ControllerItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, ControllerItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new ControllerItem.fromJson(value));
    }
    return map;
  }
}

