part of swagger.api;

class ControllerItemRes {
  /* Controller unique object id, this id is the as controllerId */
  String id = null;
  
/* Controller id */
  String controllerId = null;
  
/* 0: Tablet is Online, 1: Tablet is Offline, 2: User logout */
  String active = null;
  
/* Controller name */
  String name = null;
  
/* Controller capability http://web.siterwell.co.uk/api/apiDoc.html#controller_cap */
  List<String> caps = [];
  

  List<GroupItem> groups = [];
  

  List<PlaceItem> places = [];
  

  List<ModeItem> modes = [];
  

  List<DevPropertyItem> props = [];
  

  List<DeviceItem> devices = [];
  

  List<StatusItem> status = [];
  

  List<PrivilegeItemIn> privGroups = [];
  

  List<HwInfoItem> hwInfo = [];
  
  ControllerItemRes();

  @override
  String toString() {
    return 'ControllerItemRes[id=$id, controllerId=$controllerId, active=$active, name=$name, caps=$caps, groups=$groups, places=$places, modes=$modes, props=$props, devices=$devices, status=$status, privGroups=$privGroups, hwInfo=$hwInfo, ]';
  }

  ControllerItemRes.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    id =
        json['id']
    ;
    controllerId =
        json['controllerId']
    ;
    active =
        json['active']
    ;
    name =
        json['name']
    ;
    caps =
      //[Martin] Check Array size 0 and null 
        (json['caps'].toString()== '[]'||json['caps']== null) ? null : (json['caps'] as List).map((item) => item as String).toList()
    ;
    groups =
      GroupItem.listFromJson(json['groups'])
;
    places =
      PlaceItem.listFromJson(json['places'])
;
    modes =
      ModeItem.listFromJson(json['modes'])
;
    props =
      DevPropertyItem.listFromJson(json['props'])
;
    devices =
      DeviceItem.listFromJson(json['devices'])
;
    status =
      StatusItem.listFromJson(json['status'])
;
    privGroups =
      PrivilegeItemIn.listFromJson(json['privGroups'])
;
    hwInfo =
      HwInfoItem.listFromJson(json['hwInfo'])
;
  }

  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'controllerId': controllerId,
      'active': active,
      'name': name,
      'caps': caps,
      'groups': groups,
      'places': places,
      'modes': modes,
      'props': props,
      'devices': devices,
      'status': status,
      'privGroups': privGroups,
      'hwInfo': hwInfo
     };
  }

  static List<ControllerItemRes> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<ControllerItemRes>();
    }
    return json.map((value) => new ControllerItemRes.fromJson(value)).toList();
  }

  static Map<String, ControllerItemRes> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, ControllerItemRes>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new ControllerItemRes.fromJson(value));
    }
    return map;
  }
}

