part of swagger.api;

class DevChannelItem {
  /* Device Channel ID */
  String channelId = null;
  
/* Device Channel Name */
  String name = null;
  

  List<DevPropertyItem> props = [];
  
/* Device capability, http://web.siterwell.co.uk/api/apiDoc.html#device_cap */
  List<String> caps = [];
  
  DevChannelItem();

  @override
  String toString() {
    return 'DevChannelItem[channelId=$channelId, name=$name, props=$props, caps=$caps, ]';
  }

  DevChannelItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    channelId =
        json['channelId']
    ;
    name =
        json['name']
    ;
    props =
      DevPropertyItem.listFromJson(json['props'])
;
    caps =
      //[Martin] Check Array size 0 and null 
        (json['caps'].toString()== '[]'||json['caps']== null) ? null : (json['caps'] as List).map((item) => item as String).toList()
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'channelId': channelId,
      'name': name,
      'props': props,
      'caps': caps
     };
  }

  static List<DevChannelItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<DevChannelItem>();
    }
    return json.map((value) => new DevChannelItem.fromJson(value)).toList();
  }

  static Map<String, DevChannelItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, DevChannelItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new DevChannelItem.fromJson(value));
    }
    return map;
  }
}

