part of swagger.api;

class DeviceItem {
  /* Device id */
  String devId = null;
  
/* Device name */
  String name = null;
  
/* 0 - Device is Online, 1 - Device is Offline */
  String active = null;
  
/* Device capability, http://web.siterwell.co.uk/api/apiDoc.html#device_cap */
  List<String> caps = [];
  

  List<String> groups = [];
  

  List<DevPropertyItem> props = [];
  

  List<DevChannelItem> channels = [];
  

  List<HwInfoItem> hwInfo = [];
  
  DeviceItem();

  @override
  String toString() {
    return 'DeviceItem[devId=$devId, name=$name, active=$active, caps=$caps, groups=$groups, props=$props, channels=$channels, hwInfo=$hwInfo, ]';
  }

  DeviceItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    devId =
        json['devId']
    ;
    name =
        json['name']
    ;
    active =
        json['active']
    ;
    caps =
      //[Martin] Check Array size 0 and null 
        (json['caps'].toString()== '[]'||json['caps']== null) ? null : (json['caps'] as List).map((item) => item as String).toList()
    ;
    groups =
      //[Martin] Check Array size 0 and null 
        (json['groups'].toString()== '[]'||json['groups']== null) ? null : (json['groups'] as List).map((item) => item as String).toList()
    ;
    props =
      DevPropertyItem.listFromJson(json['props'])
;
    channels =
      DevChannelItem.listFromJson(json['channels'])
;
    hwInfo =
      HwInfoItem.listFromJson(json['hwInfo'])
;
  }

  Map<String, dynamic> toJson() {
    return {
      'devId': devId,
      'name': name,
      'active': active,
      'caps': caps,
      'groups': groups,
      'props': props,
      'channels': channels,
      'hwInfo': hwInfo
     };
  }

  static List<DeviceItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<DeviceItem>();
    }
    return json.map((value) => new DeviceItem.fromJson(value)).toList();
  }

  static Map<String, DeviceItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, DeviceItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new DeviceItem.fromJson(value));
    }
    return map;
  }
}

