part of swagger.api;

class GeoItem {
  /* Abbrevated country name in English */
  String country = null;
  
/* City name in English */
  String city = null;
  
/* Latitude in decimal(at least the first decimal precision) */
  String latitude = null;
  
/* Longitude in decimal(at least the first decimal precision) */
  String longitude = null;
  
/* Timezone in the list of tz database */
  String timezone = null;
  
  GeoItem();

  @override
  String toString() {
    return 'GeoItem[country=$country, city=$city, latitude=$latitude, longitude=$longitude, timezone=$timezone, ]';
  }

  GeoItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    country =
        json['country']
    ;
    city =
        json['city']
    ;
    latitude =
        json['latitude']
    ;
    longitude =
        json['longitude']
    ;
    timezone =
        json['timezone']
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'country': country,
      'city': city,
      'latitude': latitude,
      'longitude': longitude,
      'timezone': timezone
     };
  }

  static List<GeoItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<GeoItem>();
    }
    return json.map((value) => new GeoItem.fromJson(value)).toList();
  }

  static Map<String, GeoItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, GeoItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new GeoItem.fromJson(value));
    }
    return map;
  }
}

