part of swagger.api;

class PlaceItem {
  /* Place id */
  String id = null;
  
/* Place description name */
  String name = null;
  
/* Place icon type */
  String iconType = null;
  
/* UI display ordering */
  String order = null;
  
  PlaceItem();

  @override
  String toString() {
    return 'PlaceItem[id=$id, name=$name, iconType=$iconType, order=$order, ]';
  }

  PlaceItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    id =
        json['id']
    ;
    name =
        json['name']
    ;
    iconType =
        json['iconType']
    ;
    order =
        json['order']
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'name': name,
      'iconType': iconType,
      'order': order
     };
  }

  static List<PlaceItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<PlaceItem>();
    }
    return json.map((value) => new PlaceItem.fromJson(value)).toList();
  }

  static Map<String, PlaceItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, PlaceItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new PlaceItem.fromJson(value));
    }
    return map;
  }
}

