part of swagger.api;

class PropertyItem {
  /* Property name, http://web.siterwell.co.uk/api/apiDoc.html#controller_props */
  String name = null;
  
/* Property value, http://web.siterwell.co.uk/api/apiDoc.html#controller_props */
  String value = null;
  
  PropertyItem();

  @override
  String toString() {
    return 'PropertyItem[name=$name, value=$value, ]';
  }

  PropertyItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    name =
        json['name']
    ;
    value =
        json['value']
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'name': name,
      'value': value
     };
  }

  static List<PropertyItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<PropertyItem>();
    }
    return json.map((value) => new PropertyItem.fromJson(value)).toList();
  }

  static Map<String, PropertyItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, PropertyItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new PropertyItem.fromJson(value));
    }
    return map;
  }
}

