part of swagger.api;

class RuleItem {
  /* rule id */
  String ruleId = null;
  
/* rule name */
  String name = null;
  
/* rule description */
  String desc = null;
  
/* rule type */
  String type = null;
  //enum typeEnum {  automation,  scene,  hidden,  };
/* favorite rule or not */
  bool favorite = null;
  
/* rule mode id */
  List<String> modes = [];
  

  List<ConditionItem> conditions = [];
  

  List<ActionItem> actions = [];
  
/* schedule setting id */
  String scheduleSettingId = null;
  
  RuleItem();

  @override
  String toString() {
    return 'RuleItem[ruleId=$ruleId, name=$name, desc=$desc, type=$type, favorite=$favorite, modes=$modes, conditions=$conditions, actions=$actions, scheduleSettingId=$scheduleSettingId, ]';
  }

  RuleItem.fromJson(Map<String, dynamic> json) {
    if (json == null || json.length == 0) return;
    ruleId =
        json['ruleId']
    ;
    name =
        json['name']
    ;
    desc =
        json['desc']
    ;
    type =
        json['type']
    ;
    favorite =
        json['favorite']
    ;
    modes =
      //[Martin] Check Array size 0 and null 
        (json['modes'].toString()== '[]'||json['modes']== null) ? null : (json['modes'] as List).map((item) => item as String).toList()
    ;
    conditions =
      ConditionItem.listFromJson(json['conditions'])
;
    actions =
      ActionItem.listFromJson(json['actions'])
;
    scheduleSettingId =
        json['scheduleSettingId']
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'ruleId': ruleId,
      'name': name,
      'desc': desc,
      'type': type,
      'favorite': favorite,
      'modes': modes,
      'conditions': conditions,
      'actions': actions,
      'scheduleSettingId': scheduleSettingId
     };
  }

  static List<RuleItem> listFromJson(List<dynamic> json) {
    if(json == null || json.length == 0){
      return new List<RuleItem>();
    }
    return json.map((value) => new RuleItem.fromJson(value)).toList();
  }

  static Map<String, RuleItem> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, RuleItem>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new RuleItem.fromJson(value));
    }
    return map;
  }
}

